## ck 0.3.5

=== regressions/Makefile ===
DIR=array	\
    backoff	\
    barrier	\
    bitmap	\
    brlock	\
    bytelock	\
    cohort	\
    epoch	\
    fifo	\
    hp		\
    hs		\
    ht		\
    pflock	\
    pr		\
    queue	\
    ring	\
    rwlock	\
    sequence	\
    spinlock	\
    stack

.PHONY: all clean check

all:
	$(MAKE) -C ./ck_array/validate all
	$(MAKE) -C ./ck_cohort/validate all
	$(MAKE) -C ./ck_cohort/benchmark all
	$(MAKE) -C ./ck_bitmap/validate all
	$(MAKE) -C ./ck_backoff/validate all
	$(MAKE) -C ./ck_queue/validate all
	$(MAKE) -C ./ck_brlock/validate all
	$(MAKE) -C ./ck_ht/validate all
	$(MAKE) -C ./ck_ht/benchmark all
	$(MAKE) -C ./ck_brlock/benchmark all
	$(MAKE) -C ./ck_spinlock/validate all
	$(MAKE) -C ./ck_spinlock/benchmark all
	$(MAKE) -C ./ck_fifo/validate all
	$(MAKE) -C ./ck_fifo/benchmark all
	$(MAKE) -C ./ck_pr/validate all
	$(MAKE) -C ./ck_pr/benchmark all
	$(MAKE) -C ./ck_hs/benchmark all
	$(MAKE) -C ./ck_hs/validate all
	$(MAKE) -C ./ck_barrier/validate all
	$(MAKE) -C ./ck_barrier/benchmark all
	$(MAKE) -C ./ck_bytelock/validate all
	$(MAKE) -C ./ck_bytelock/benchmark all
	$(MAKE) -C ./ck_epoch/validate all
	$(MAKE) -C ./ck_rwcohort/validate all
	$(MAKE) -C ./ck_rwcohort/benchmark all
	$(MAKE) -C ./ck_sequence/validate all
	$(MAKE) -C ./ck_sequence/benchmark all
	$(MAKE) -C ./ck_stack/validate all
	$(MAKE) -C ./ck_stack/benchmark all
	$(MAKE) -C ./ck_ring/validate all
	$(MAKE) -C ./ck_ring/benchmark all
	$(MAKE) -C ./ck_rwlock/validate all
	$(MAKE) -C ./ck_rwlock/benchmark all
	$(MAKE) -C ./ck_pflock/validate all
	$(MAKE) -C ./ck_pflock/benchmark all
	$(MAKE) -C ./ck_hp/validate all
	$(MAKE) -C ./ck_hp/benchmark all

clean:
	$(MAKE) -C ./ck_array/validate clean
	$(MAKE) -C ./ck_pflock/validate clean
	$(MAKE) -C ./ck_pflock/benchmark clean
	$(MAKE) -C ./ck_rwcohort/validate clean
	$(MAKE) -C ./ck_rwcohort/benchmark clean
	$(MAKE) -C ./ck_backoff/validate clean
	$(MAKE) -C ./ck_bitmap/validate clean
	$(MAKE) -C ./ck_queue/validate clean
	$(MAKE) -C ./ck_cohort/validate clean
	$(MAKE) -C ./ck_cohort/benchmark clean
	$(MAKE) -C ./ck_brlock/validate clean
	$(MAKE) -C ./ck_ht/validate clean
	$(MAKE) -C ./ck_ht/benchmark clean
	$(MAKE) -C ./ck_hs/validate clean
	$(MAKE) -C ./ck_hs/benchmark clean
	$(MAKE) -C ./ck_brlock/benchmark clean
	$(MAKE) -C ./ck_spinlock/validate clean
	$(MAKE) -C ./ck_spinlock/benchmark clean
	$(MAKE) -C ./ck_fifo/validate clean
	$(MAKE) -C ./ck_fifo/benchmark clean
	$(MAKE) -C ./ck_pr/validate clean
	$(MAKE) -C ./ck_pr/benchmark clean
	$(MAKE) -C ./ck_barrier/validate clean
	$(MAKE) -C ./ck_barrier/benchmark clean
	$(MAKE) -C ./ck_bytelock/validate clean
	$(MAKE) -C ./ck_bytelock/benchmark clean
	$(MAKE) -C ./ck_epoch/validate clean
	$(MAKE) -C ./ck_sequence/validate clean
	$(MAKE) -C ./ck_sequence/benchmark clean
	$(MAKE) -C ./ck_stack/validate clean
	$(MAKE) -C ./ck_stack/benchmark clean
	$(MAKE) -C ./ck_ring/validate clean
	$(MAKE) -C ./ck_ring/benchmark clean
	$(MAKE) -C ./ck_rwlock/validate clean
	$(MAKE) -C ./ck_rwlock/benchmark clean
	$(MAKE) -C ./ck_pflock/validate clean
	$(MAKE) -C ./ck_pflock/benchmark clean
	$(MAKE) -C ./ck_hp/validate clean
	$(MAKE) -C ./ck_hp/benchmark clean

check: all
	rc=0; 							\
	for d in $(DIR) ; do					\
		echo "----[ Testing $$d....";			\
		$(MAKE) -C ./ck_$$d/validate check || rc=1; 	\
		echo;						\
	done; 							\
	exit $$rc

=== regressions/ck_fifo/validate/Makefile ===
.PHONY: check clean distribution

OBJECTS=ck_fifo_spsc ck_fifo_mpmc ck_fifo_spsc_iterator ck_fifo_mpmc_iterator

all: $(OBJECTS)

check: all
	./ck_fifo_spsc $(CORES) 1 64000
	./ck_fifo_mpmc $(CORES) 1 16000
	./ck_fifo_spsc_iterator
	./ck_fifo_mpmc_iterator

ck_fifo_spsc: ck_fifo_spsc.c ../../../include/ck_fifo.h
	$(CC) $(CFLAGS) -o ck_fifo_spsc ck_fifo_spsc.c

ck_fifo_mpmc: ck_fifo_mpmc.c ../../../include/ck_fifo.h
	$(CC) $(CFLAGS) -o ck_fifo_mpmc ck_fifo_mpmc.c

ck_fifo_spsc_iterator: ck_fifo_spsc_iterator.c ../../../include/ck_fifo.h
	$(CC) $(CFLAGS) -o ck_fifo_spsc_iterator ck_fifo_spsc_iterator.c

ck_fifo_mpmc_iterator: ck_fifo_mpmc_iterator.c ../../../include/ck_fifo.h
	$(CC) $(CFLAGS) -o ck_fifo_mpmc_iterator ck_fifo_mpmc_iterator.c

clean:
	rm -rf *.dSYM *.exe *~ *.o $(OBJECTS)

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE

=== regressions/ck_hs/benchmark/Makefile ===
.PHONY: clean distribution

OBJECTS=serial parallel_bytestring parallel_bytestring.delete

all: $(OBJECTS)

serial: serial.c ../../../include/ck_hs.h ../../../src/ck_hs.c
	$(CC) $(CFLAGS) -o serial serial.c ../../../src/ck_hs.c

parallel_bytestring: parallel_bytestring.c ../../../include/ck_hs.h ../../../src/ck_hs.c ../../../src/ck_epoch.c
	$(CC) $(PTHREAD_CFLAGS) $(CFLAGS) -o parallel_bytestring parallel_bytestring.c ../../../src/ck_hs.c ../../../src/ck_epoch.c

parallel_bytestring.delete: parallel_bytestring.c ../../../include/ck_hs.h ../../../src/ck_hs.c ../../../src/ck_epoch.c
	$(CC) $(PTHREAD_CFLAGS) $(CFLAGS) -DHS_DELETE -o parallel_bytestring.delete parallel_bytestring.c ../../../src/ck_hs.c ../../../src/ck_epoch.c

clean:
	rm -rf *~ *.o $(OBJECTS) *.dSYM *.exe

include ../../../build/regressions.build
CFLAGS+=-D_GNU_SOURCE

## ck 0.4.4

=== regressions/ck_epoch/validate/Makefile ===
.PHONY: check clean distribution

OBJECTS=ck_stack ck_epoch_synchronize ck_epoch_poll
HALF=`expr $(CORES) / 2`

all: $(OBJECTS)

check: all
	./ck_stack $(CORES) 1
	./ck_epoch_synchronize $(HALF) $(HALF) 1
	./ck_epoch_poll $(CORES) 1 1

ck_epoch_synchronize: ck_epoch_synchronize.c ../../../include/ck_stack.h ../../../include/ck_epoch.h ../../../src/ck_epoch.c
	$(CC) $(CFLAGS) -o ck_epoch_synchronize ck_epoch_synchronize.c ../../../src/ck_epoch.c

ck_epoch_poll: ck_epoch_poll.c ../../../include/ck_stack.h ../../../include/ck_epoch.h ../../../src/ck_epoch.c
	$(CC) $(CFLAGS) -o ck_epoch_poll ck_epoch_poll.c ../../../src/ck_epoch.c

ck_stack: ck_stack.c ../../../include/ck_stack.h ../../../include/ck_epoch.h ../../../src/ck_epoch.c
	$(CC) $(CFLAGS) -o ck_stack ck_stack.c ../../../src/ck_epoch.c

clean:
	rm -rf *~ *.o $(OBJECTS) *.dSYM *.exe

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE

=== regressions/ck_pr/benchmark/Makefile ===
.PHONY: clean

all: ck_pr_cas_64 ck_pr_fas_64 ck_pr_cas_64_2

ck_pr_cas_64_2: ck_pr_cas_64_2.c
	$(CC) $(CFLAGS) -o ck_pr_cas_64_2 ck_pr_cas_64_2.c -lm

ck_pr_cas_64: ck_pr_cas_64.c
	$(CC) $(CFLAGS) -o ck_pr_cas_64 ck_pr_cas_64.c -lm

ck_pr_fas_64: ck_pr_fas_64.c
	$(CC) $(CFLAGS) -o ck_pr_fas_64 ck_pr_fas_64.c -lm

clean:
	rm -rf ck_pr_cas_64 ck_pr_fas_64 ck_pr_cas_64_2 *.dSYM *.exe

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE

=== regressions/ck_pr/validate/Makefile ===
.PHONY: check clean distribution

OBJECTS=ck_pr_cas ck_pr_faa ck_pr_inc ck_pr_dec ck_pr_bts \
	ck_pr_btr ck_pr_btc ck_pr_load ck_pr_store 	  \
	ck_pr_and ck_pr_or ck_pr_xor ck_pr_add ck_pr_sub  \
	ck_pr_fas ck_pr_bin ck_pr_btx ck_pr_fax ck_pr_n	  \
	ck_pr_unary

all: $(OBJECTS)

check: all
	for d in $(OBJECTS) ; do        \
		echo $$d;		\
		./$$d || exit 1;     	\
	done;

ck_pr_cas: ck_pr_cas.c
	$(CC) $(CFLAGS) -o ck_pr_cas ck_pr_cas.c

ck_pr_inc: ck_pr_inc.c
	$(CC) $(CFLAGS) -o ck_pr_inc ck_pr_inc.c

ck_pr_dec: ck_pr_dec.c
	$(CC) $(CFLAGS) -o ck_pr_dec ck_pr_dec.c

ck_pr_faa: ck_pr_faa.c
	$(CC) $(CFLAGS) -o ck_pr_faa ck_pr_faa.c

ck_pr_btc: ck_pr_btc.c
	$(CC) $(CFLAGS) -o ck_pr_btc ck_pr_btc.c

ck_pr_btr: ck_pr_btr.c
	$(CC) $(CFLAGS) -o ck_pr_btr ck_pr_btr.c

ck_pr_bts: ck_pr_bts.c
	$(CC) $(CFLAGS) -o ck_pr_bts ck_pr_bts.c

ck_pr_load: ck_pr_load.c
	$(CC) $(CFLAGS) -o ck_pr_load ck_pr_load.c

ck_pr_store: ck_pr_store.c
	$(CC) $(CFLAGS) -o ck_pr_store ck_pr_store.c

ck_pr_and: ck_pr_and.c
	$(CC) $(CFLAGS) -o ck_pr_and ck_pr_and.c

ck_pr_or: ck_pr_or.c
	$(CC) $(CFLAGS) -o ck_pr_or ck_pr_or.c

ck_pr_xor: ck_pr_xor.c
	$(CC) $(CFLAGS) -o ck_pr_xor ck_pr_xor.c

ck_pr_add: ck_pr_add.c
	$(CC) $(CFLAGS) -o ck_pr_add ck_pr_add.c

ck_pr_sub: ck_pr_sub.c
	$(CC) $(CFLAGS) -o ck_pr_sub ck_pr_sub.c

ck_pr_fas: ck_pr_fas.c
	$(CC) $(CFLAGS) -o ck_pr_fas ck_pr_fas.c

ck_tp: ck_tp.c
	$(CC) $(CFLAGS) -o ck_tp ck_tp.c

ck_pr_bin: ck_pr_bin.c
	$(CC) $(CFLAGS) -o ck_pr_bin ck_pr_bin.c

ck_pr_btx: ck_pr_btx.c
	$(CC) $(CFLAGS) -o ck_pr_btx ck_pr_btx.c

ck_pr_fax: ck_pr_fax.c
	$(CC) $(CFLAGS) -o ck_pr_fax ck_pr_fax.c

ck_pr_n: ck_pr_n.c
	$(CC) $(CFLAGS) -o ck_pr_n ck_pr_n.c

ck_pr_unary: ck_pr_unary.c
	$(CC) $(CFLAGS) -o ck_pr_unary ck_pr_unary.c

clean:
	rm -rf *~ *.o $(OBJECTS) *.dSYM *.exe

include ../../../build/regressions.build
CFLAGS+=-D_GNU_SOURCE

=== regressions/ck_ring/validate/Makefile ===
.PHONY: check clean distribution

OBJECTS=ck_ring_spsc ck_ring_spmc ck_ring_spmc_template
SIZE=16384
CFLAGS += -g2

all: $(OBJECTS)

check: all
	./ck_ring_spsc $(CORES) 1 $(SIZE)
	./ck_ring_spmc $(CORES) 1 $(SIZE)

ck_ring_spsc: ck_ring_spsc.c ../../../include/ck_ring.h
	$(CC) $(CFLAGS) -o ck_ring_spsc ck_ring_spsc.c \
		../../../src/ck_barrier_centralized.c

ck_ring_spmc: ck_ring_spmc.c ../../../include/ck_ring.h
	$(CC) $(CFLAGS) -g2  -o ck_ring_spmc ck_ring_spmc.c \
		../../../src/ck_barrier_centralized.c

ck_ring_spmc_template: ck_ring_spmc_template.c ../../../include/ck_ring.h
	$(CC) $(CFLAGS) -g2  -o ck_ring_spmc_template ck_ring_spmc.c \
		../../../src/ck_barrier_centralized.c

clean:
	rm -rf *~ *.o $(OBJECTS) *.dSYM *.exe

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE

=== regressions/ck_spinlock/validate/Makefile ===
.PHONY: check clean

all: ck_ticket ck_mcs ck_dec ck_cas ck_fas ck_clh linux_spinlock \
     ck_ticket_pb ck_anderson ck_spinlock ck_hclh

check: all
	./ck_ticket $(CORES) 1
	./ck_mcs $(CORES) 1
	./ck_dec $(CORES) 1
	./ck_cas $(CORES) 1
	./ck_fas $(CORES) 1
	./ck_clh $(CORES) 1
	./linux_spinlock $(CORES) 1
	./ck_ticket_pb $(CORES) 1
	./ck_anderson $(CORES) 1
	./ck_spinlock $(CORES) 1

linux_spinlock: linux_spinlock.c
	$(CC) $(CFLAGS) -o linux_spinlock linux_spinlock.c

ck_spinlock: ck_spinlock.c
	$(CC) $(CFLAGS) -o ck_spinlock ck_spinlock.c

ck_ticket_pb: ck_ticket_pb.c
	$(CC) $(CFLAGS) -o ck_ticket_pb ck_ticket_pb.c

ck_clh: ck_clh.c
	$(CC) $(CFLAGS) -o ck_clh ck_clh.c

ck_hclh: ck_hclh.c
	$(CC) $(CFLAGS) -o ck_hclh ck_hclh.c

ck_anderson: ck_anderson.c
	$(CC) $(CFLAGS) -o ck_anderson ck_anderson.c

ck_fas: ck_fas.c
	$(CC) $(CFLAGS) -o ck_fas ck_fas.c

ck_ticket: ck_ticket.c
	$(CC) $(CFLAGS) -o ck_ticket ck_ticket.c

ck_cas: ck_cas.c
	$(CC) $(CFLAGS) -o ck_cas ck_cas.c

ck_mcs: ck_mcs.c
	$(CC) $(CFLAGS) -o ck_mcs ck_mcs.c

ck_dec: ck_dec.c
	$(CC) $(CFLAGS) -o ck_dec ck_dec.c

clean:
	rm -rf ck_ticket ck_mcs ck_dec ck_cas ck_fas ck_clh linux_spinlock ck_ticket_pb \
		ck_anderson ck_spinlock *.dSYM *.exe

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE -lm

=== debian/changelog ===
ck (0.4.4-2) unstable; urgency=low

  * Update maintainer to Debian QA up (orphaning the package)

 -- Daniel Pocock <daniel@pocock.pro>  Mon, 19 Dec 2016 10:07:18 +0100

ck (0.4.4-1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Pocock <daniel@pocock.pro>  Wed, 10 Sep 2014 22:16:03 +0200

ck (0.4.3-1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Pocock <daniel@pocock.pro>  Sat, 02 Aug 2014 16:28:29 +0200

ck (0.4.2-1) unstable; urgency=medium

  * New upstream release.
  * Fixes some build issues for non-Intel platforms.

 -- Daniel Pocock <daniel@pocock.pro>  Fri, 02 May 2014 09:17:48 +0200

ck (0.3.5-1) unstable; urgency=low

  * Initial packaging (Closes: #740392)

 -- Daniel Pocock <daniel@pocock.com.au>  Fri, 28 Feb 2014 23:48:09 +0100

=== debian/control ===
Source: ck
Section: libs
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.5
Homepage: http://concurrencykit.org/
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/ck.git
Vcs-Git: git://anonscm.debian.org/collab-maint/ck.git

Package: libck0
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Concurrency Kit - shared libraries
 Concurrency primitives, safe memory reclamation mechanisms and
 non-blocking data structures designed to aid in the research,
 design and implementation of high performance concurrent systems.

Package: libck-dev
Section: libdevel
Architecture: any
Depends: libck0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Concurrency Kit - development files
 Concurrency primitives, safe memory reclamation mechanisms and
 non-blocking data structures designed to aid in the research,
 design and implementation of high performance concurrent systems.
 .
 This package provides header files needed by developers.

## ck 0.5.2

=== regressions/ck_pr/benchmark/Makefile ===
--- 
+++ 
@@ -1,6 +1,9 @@
 .PHONY: clean
 
-all: ck_pr_cas_64 ck_pr_fas_64 ck_pr_cas_64_2
+all: ck_pr_cas_64 ck_pr_fas_64 ck_pr_cas_64_2 fp
+
+fp: fp.c
+	$(CC) $(CFLAGS) -o fp fp.c
 
 ck_pr_cas_64_2: ck_pr_cas_64_2.c
 	$(CC) $(CFLAGS) -o ck_pr_cas_64_2 ck_pr_cas_64_2.c -lm

=== debian/changelog ===
ck (0.5.2-1) unstable; urgency=medium

  * New upstream version 0.5.2 (Closes: #813145)
  * debian/control: Update Maintainer (Closes: #848656)
  * debian/control: Use HTTPS Vcs-* URLs
  * debian/control: Standards-Version 3.9.8 (no changes)
  * debian/control: Build-Depend on debhelper 10
  * debian/compat: Compat level 10
  * debian/copyright: BSD -> BSD-2-clause (Fixes Lintian
    "invalid-short-name-in-dep5-copyright")
  * debian/copyright: Remove Source header (dead link)
  * debian/copyright: Correct path to include/gcc/x86_64/ck_pr_rtm.h (Fixes
    Lintian "wildcard-matches-nothing-in-dep5-copyright ck_pr_rtm",
    "unused-file-paragraph-in-dep5-copyright")
  * debian/watch: Add watch file for GitHub releases
  * debian/source/: Use 3.0 (quilt) source format, plus options and patch
    header

 -- Robert Edmonds <edmonds@debian.org>  Wed, 21 Dec 2016 18:59:51 -0500

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: ck
 Section: libs
 Priority: optional
-Maintainer: Debian QA Group <packages@qa.debian.org>
-Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.5
+Maintainer: Robert Edmonds <edmonds@debian.org>
+Build-Depends: debhelper (>= 10)
+Standards-Version: 3.9.8
 Homepage: http://concurrencykit.org/
-Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/ck.git
-Vcs-Git: git://anonscm.debian.org/collab-maint/ck.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/ck.git
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/ck.git
 
 Package: libck0
 Architecture: any
@@ -27,5 +27,3 @@
  design and implementation of high performance concurrent systems.
  .
  This package provides header files needed by developers.
-
-

=== debian/rules ===
#!/usr/bin/make -f

override_dh_auto_configure:
	./configure --includedir=/usr/include --libdir=/usr/lib/$(DEB_HOST_MULTIARCH) --mandir=/usr/share/man --prefix=/usr

%:
	dh $@

.PHONY: build

## ck 0.6.0

=== regressions/Makefile ===
--- 
+++ 
@@ -9,15 +9,19 @@
     fifo	\
     hp		\
     hs		\
+    rhs		\
     ht		\
     pflock	\
     pr		\
     queue	\
     ring	\
     rwlock	\
+    swlock	\
     sequence	\
     spinlock	\
-    stack
+    stack	\
+    swlock	\
+    tflock
 
 .PHONY: all clean check
 
@@ -40,6 +44,8 @@
 	$(MAKE) -C ./ck_pr/benchmark all
 	$(MAKE) -C ./ck_hs/benchmark all
 	$(MAKE) -C ./ck_hs/validate all
+	$(MAKE) -C ./ck_rhs/benchmark all
+	$(MAKE) -C ./ck_rhs/validate all
 	$(MAKE) -C ./ck_barrier/validate all
 	$(MAKE) -C ./ck_barrier/benchmark all
 	$(MAKE) -C ./ck_bytelock/validate all
@@ -55,6 +61,10 @@
 	$(MAKE) -C ./ck_ring/benchmark all
 	$(MAKE) -C ./ck_rwlock/validate all
 	$(MAKE) -C ./ck_rwlock/benchmark all
+	$(MAKE) -C ./ck_tflock/validate all
+	$(MAKE) -C ./ck_tflock/benchmark all
+	$(MAKE) -C ./ck_swlock/validate all
+	$(MAKE) -C ./ck_swlock/benchmark all
 	$(MAKE) -C ./ck_pflock/validate all
 	$(MAKE) -C ./ck_pflock/benchmark all
 	$(MAKE) -C ./ck_hp/validate all
@@ -64,6 +74,8 @@
 	$(MAKE) -C ./ck_array/validate clean
 	$(MAKE) -C ./ck_pflock/validate clean
 	$(MAKE) -C ./ck_pflock/benchmark clean
+	$(MAKE) -C ./ck_tflock/validate clean
+	$(MAKE) -C ./ck_tflock/benchmark clean
 	$(MAKE) -C ./ck_rwcohort/validate clean
 	$(MAKE) -C ./ck_rwcohort/benchmark clean
 	$(MAKE) -C ./ck_backoff/validate clean
@@ -76,6 +88,8 @@
 	$(MAKE) -C ./ck_ht/benchmark clean
 	$(MAKE) -C ./ck_hs/validate clean
 	$(MAKE) -C ./ck_hs/benchmark clean
+	$(MAKE) -C ./ck_rhs/validate clean
+	$(MAKE) -C ./ck_rhs/benchmark clean
 	$(MAKE) -C ./ck_brlock/benchmark clean
 	$(MAKE) -C ./ck_spinlock/validate clean
 	$(MAKE) -C ./ck_spinlock/benchmark clean
@@ -96,6 +110,8 @@
 	$(MAKE) -C ./ck_ring/benchmark clean
 	$(MAKE) -C ./ck_rwlock/validate clean
 	$(MAKE) -C ./ck_rwlock/benchmark clean
+	$(MAKE) -C ./ck_swlock/validate clean
+	$(MAKE) -C ./ck_swlock/benchmark clean
 	$(MAKE) -C ./ck_pflock/validate clean
 	$(MAKE) -C ./ck_pflock/benchmark clean
 	$(MAKE) -C ./ck_hp/validate clean

=== regressions/ck_barrier/benchmark/Makefile ===
.PHONY: clean distribution

OBJECTS=throughput

all: $(OBJECTS)

throughput: throughput.c ../../../include/ck_barrier.h ../../../src/ck_barrier_centralized.c
	$(CC) $(CFLAGS) -o throughput throughput.c ../../../src/ck_barrier_centralized.c

clean:
	rm -rf *.dSYM *.exe *~ *.o $(OBJECTS)

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE

=== regressions/ck_barrier/validate/Makefile ===
.PHONY: check clean distribution

OBJECTS=barrier_centralized barrier_combining barrier_dissemination barrier_tournament barrier_mcs

all: $(OBJECTS)

barrier_centralized: barrier_centralized.c ../../../include/ck_barrier.h ../../../src/ck_barrier_centralized.c
	$(CC) $(CFLAGS) -o barrier_centralized barrier_centralized.c ../../../src/ck_barrier_centralized.c

barrier_combining: barrier_combining.c ../../../include/ck_barrier.h ../../../src/ck_barrier_combining.c
	$(CC) $(CFLAGS) -o barrier_combining barrier_combining.c ../../../src/ck_barrier_combining.c

barrier_dissemination: barrier_dissemination.c ../../../include/ck_barrier.h ../../../src/ck_barrier_dissemination.c
	$(CC) $(CFLAGS) -o barrier_dissemination barrier_dissemination.c ../../../src/ck_barrier_dissemination.c

barrier_tournament: barrier_tournament.c ../../../include/ck_barrier.h ../../../src/ck_barrier_tournament.c
	$(CC) $(CFLAGS) -o barrier_tournament barrier_tournament.c ../../../src/ck_barrier_tournament.c

barrier_mcs: barrier_mcs.c ../../../include/ck_barrier.h ../../../src/ck_barrier_mcs.c
	$(CC) $(CFLAGS) -o barrier_mcs barrier_mcs.c ../../../src/ck_barrier_mcs.c

check: all
	rc=0;                                                   \
	for d in $(OBJECTS) ; do                                \
		echo $$d;					\
		./$$d $(CORES) 1 1 || rc=1;     		\
	done;                                                   \
	exit $$rc

clean:
	rm -rf *.dSYM *.exe *~ *.o $(OBJECTS)

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE

=== regressions/ck_brlock/validate/Makefile ===
.PHONY: check clean distribution

OBJECTS=validate

all: $(OBJECTS)

validate: validate.c ../../../include/ck_brlock.h
	$(CC) $(CFLAGS) -o validate validate.c

check: all
	./validate $(CORES) 1

clean:
	rm -rf *.dSYM *.exe *~ *.o $(OBJECTS)

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE

=== regressions/ck_bytelock/validate/Makefile ===
.PHONY: check clean distribution

OBJECTS=validate

all: $(OBJECTS)

validate: validate.c ../../../include/ck_bytelock.h
	$(CC) $(CFLAGS) -o validate validate.c

check: all
	./validate $(CORES) 1

clean:
	rm -rf *.dSYM *.exe *~ *.o $(OBJECTS)

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE

=== regressions/ck_hp/validate/Makefile ===
.PHONY: check clean distribution

OBJECTS=ck_hp_stack nbds_haz_test serial ck_hp_fifo ck_hp_fifo_donner

all: $(OBJECTS)

check: all
	./serial
	./ck_hp_stack $(CORES) 100 1
	./ck_hp_fifo $(CORES) 1 16384 100
	./nbds_haz_test $(CORES) 15 1
	./ck_hp_fifo_donner $(CORES) 16384

ck_hp_stack: ../../../src/ck_hp.c ck_hp_stack.c ../../../include/ck_hp_stack.h
	$(CC) $(CFLAGS) ../../../src/ck_hp.c -o ck_hp_stack ck_hp_stack.c

ck_hp_fifo: ../../../src/ck_hp.c ck_hp_fifo.c ../../../include/ck_hp_fifo.h
	$(CC) $(CFLAGS) ../../../src/ck_hp.c -o ck_hp_fifo ck_hp_fifo.c

ck_hp_fifo_donner: ../../../src/ck_hp.c ck_hp_fifo_donner.c ../../../include/ck_hp_fifo.h
	$(CC) $(CFLAGS) ../../../src/ck_hp.c -o ck_hp_fifo_donner ck_hp_fifo_donner.c

serial: ../../../src/ck_hp.c serial.c ../../../include/ck_hp_stack.h
	$(CC) $(CFLAGS) ../../../src/ck_hp.c -o serial serial.c

nbds_haz_test: ../../../src/ck_hp.c nbds_haz_test.c
	$(CC) $(CFLAGS) ../../../src/ck_hp.c -o nbds_haz_test nbds_haz_test.c

clean:
	rm -rf *~ *.o *.dSYM *.exe $(OBJECTS)

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE

=== regressions/ck_hs/benchmark/Makefile ===
--- 
+++ 
@@ -1,11 +1,14 @@
 .PHONY: clean distribution
 
-OBJECTS=serial parallel_bytestring parallel_bytestring.delete
+OBJECTS=serial parallel_bytestring parallel_bytestring.delete apply
 
 all: $(OBJECTS)
 
 serial: serial.c ../../../include/ck_hs.h ../../../src/ck_hs.c
 	$(CC) $(CFLAGS) -o serial serial.c ../../../src/ck_hs.c
+
+apply: apply.c ../../../include/ck_hs.h ../../../src/ck_hs.c
+	$(CC) $(CFLAGS) -o apply apply.c ../../../src/ck_hs.c
 
 parallel_bytestring: parallel_bytestring.c ../../../include/ck_hs.h ../../../src/ck_hs.c ../../../src/ck_epoch.c
 	$(CC) $(PTHREAD_CFLAGS) $(CFLAGS) -o parallel_bytestring parallel_bytestring.c ../../../src/ck_hs.c ../../../src/ck_epoch.c

=== regressions/ck_ht/benchmark/Makefile ===
.PHONY: clean distribution

OBJECTS=serial serial.delete parallel_bytestring parallel_bytestring.delete parallel_direct

all: $(OBJECTS)

serial: serial.c ../../../include/ck_ht.h ../../../src/ck_ht.c
	$(CC) $(CFLAGS) -o serial serial.c ../../../src/ck_ht.c

serial.delete: serial.c ../../../include/ck_ht.h ../../../src/ck_ht.c
	$(CC) $(CFLAGS) -DHT_DELETE -o serial.delete serial.c ../../../src/ck_ht.c

parallel_bytestring.delete: parallel_bytestring.c ../../../include/ck_ht.h ../../../src/ck_ht.c ../../../src/ck_epoch.c
	$(CC) $(PTHREAD_CFLAGS) $(CFLAGS) -DHT_DELETE -o parallel_bytestring.delete parallel_bytestring.c ../../../src/ck_ht.c ../../../src/ck_epoch.c

parallel_bytestring: parallel_bytestring.c ../../../include/ck_ht.h ../../../src/ck_ht.c ../../../src/ck_epoch.c
	$(CC) $(PTHREAD_CFLAGS) $(CFLAGS) -o parallel_bytestring parallel_bytestring.c ../../../src/ck_ht.c ../../../src/ck_epoch.c

parallel_direct: parallel_direct.c ../../../include/ck_ht.h ../../../src/ck_ht.c ../../../src/ck_epoch.c
	$(CC) $(PTHREAD_CFLAGS) $(CFLAGS) -o parallel_direct parallel_direct.c ../../../src/ck_ht.c ../../../src/ck_epoch.c

clean:
	rm -rf *~ *.o $(OBJECTS) *.dSYM *.exe

include ../../../build/regressions.build
CFLAGS+=-D_GNU_SOURCE

=== regressions/ck_ht/validate/Makefile ===
.PHONY: check clean distribution

OBJECTS=serial serial.delete

all: $(OBJECTS)

serial: serial.c ../../../include/ck_ht.h ../../../src/ck_ht.c
	$(CC) $(CFLAGS) -o serial serial.c ../../../src/ck_ht.c

serial.delete: serial.c ../../../include/ck_ht.h ../../../src/ck_ht.c
	$(CC) $(CFLAGS) -DHT_DELETE -o serial.delete serial.c ../../../src/ck_ht.c

check: all
	./serial
	./serial.delete

clean:
	rm -rf *~ *.o $(OBJECTS) *.dSYM *.exe

include ../../../build/regressions.build
CFLAGS+=-D_GNU_SOURCE

=== regressions/ck_pflock/benchmark/Makefile ===
.PHONY: clean distribution

OBJECTS=latency throughput

all: $(OBJECTS)

latency: latency.c ../../../include/ck_rwlock.h
	$(CC) $(CFLAGS) -o latency latency.c

throughput: throughput.c ../../../include/ck_rwlock.h
	$(CC) $(CFLAGS) -o throughput throughput.c

clean:
	rm -rf *.dSYM *.exe *~ *.o $(OBJECTS)

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE

=== regressions/ck_rhs/benchmark/Makefile ===
.PHONY: clean distribution

OBJECTS=serial parallel_bytestring

all: $(OBJECTS)

serial: serial.c ../../../include/ck_rhs.h ../../../src/ck_rhs.c
	$(CC) $(CFLAGS) -o serial serial.c ../../../src/ck_rhs.c

parallel_bytestring: parallel_bytestring.c ../../../include/ck_rhs.h ../../../src/ck_rhs.c ../../../src/ck_epoch.c
	$(CC) $(PTHREAD_CFLAGS) $(CFLAGS) -o parallel_bytestring parallel_bytestring.c ../../../src/ck_rhs.c ../../../src/ck_epoch.c

clean:
	rm -rf *~ *.o $(OBJECTS) *.dSYM *.exe

include ../../../build/regressions.build
CFLAGS+=-D_GNU_SOURCE

=== regressions/ck_ring/validate/Makefile ===
.PHONY: check clean distribution

OBJECTS=ck_ring_spsc ck_ring_spmc ck_ring_spmc_template ck_ring_mpmc \
	ck_ring_mpmc_template
SIZE=16384

all: $(OBJECTS)

check: all
	./ck_ring_spsc $(CORES) 1 $(SIZE)
	./ck_ring_spmc $(CORES) 1 $(SIZE)
	./ck_ring_spmc_template $(CORES) 1 $(SIZE)
	./ck_ring_mpmc $(CORES) 1 $(SIZE)
	./ck_ring_mpmc_template $(CORES) 1 $(SIZE)

ck_ring_spsc: ck_ring_spsc.c ../../../include/ck_ring.h
	$(CC) $(CFLAGS) -o ck_ring_spsc ck_ring_spsc.c \
		../../../src/ck_barrier_centralized.c

ck_ring_spmc: ck_ring_spmc.c ../../../include/ck_ring.h
	$(CC) $(CFLAGS) -o ck_ring_spmc ck_ring_spmc.c \
		../../../src/ck_barrier_centralized.c

ck_ring_mpmc: ck_ring_mpmc.c ../../../include/ck_ring.h
	$(CC) $(CFLAGS) -o ck_ring_mpmc ck_ring_mpmc.c \
		../../../src/ck_barrier_centralized.c

ck_ring_mpmc_template: ck_ring_mpmc_template.c ../../../include/ck_ring.h
	$(CC) $(CFLAGS) -o ck_ring_mpmc_template ck_ring_mpmc_template.c \
		../../../src/ck_barrier_centralized.c

ck_ring_spmc_template: ck_ring_spmc_template.c ../../../include/ck_ring.h
	$(CC) $(CFLAGS) -o ck_ring_spmc_template ck_ring_spmc_template.c \
		../../../src/ck_barrier_centralized.c

clean:
	rm -rf *~ *.o $(OBJECTS) *.dSYM *.exe

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE

=== debian/changelog ===
ck (0.6.0-1) unstable; urgency=medium

  * New upstream version 0.6.0

 -- Robert Edmonds <edmonds@debian.org>  Fri, 10 Mar 2017 18:38:50 -0500

ck (0.5.2-2) unstable; urgency=medium

  * debian/control: Only build on architectures supported by upstream
  * debian/rules: Limit tests to 2 cores (Closes: #764827)
  * debian/gbp.conf: New (enable pristine-tar, pristine-tar-commit)

 -- Robert Edmonds <edmonds@debian.org>  Thu, 29 Dec 2016 16:59:42 -0500

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/ck.git
 
 Package: libck0
-Architecture: any
+Architecture: amd64 arm64 armhf i386 ppc64el
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Concurrency Kit - shared libraries
@@ -19,7 +19,7 @@
 
 Package: libck-dev
 Section: libdevel
-Architecture: any
+Architecture: amd64 arm64 armhf i386 ppc64el
 Depends: libck0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
 Description: Concurrency Kit - development files
  Concurrency primitives, safe memory reclamation mechanisms and

=== debian/rules ===
#!/usr/bin/make -f

override_dh_auto_configure:
	./configure						\
		--includedir=/usr/include			\
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH)		\
		--mandir=/usr/share/man				\
		--prefix=/usr					\
		--cores=2

override_dh_auto_test:
	make -j1 check

%:
	dh $@

.PHONY: build

=== debian/watch ===
version=2
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/<project>-$1\.tar\.gz/ \
  https://github.com/concurrencykit/ck/releases .*/v?(\d\S+)\.tar\.gz

## ck 0.7.1

=== regressions/Makefile ===
--- 
+++ 
@@ -4,7 +4,9 @@
     bitmap	\
     brlock	\
     bytelock	\
+    cc		\
     cohort	\
+    ec		\
     epoch	\
     fifo	\
     hp		\
@@ -27,6 +29,7 @@
 
 all:
 	$(MAKE) -C ./ck_array/validate all
+	$(MAKE) -C ./ck_cc/validate all
 	$(MAKE) -C ./ck_cohort/validate all
 	$(MAKE) -C ./ck_cohort/benchmark all
 	$(MAKE) -C ./ck_bitmap/validate all
@@ -69,9 +72,12 @@
 	$(MAKE) -C ./ck_pflock/benchmark all
 	$(MAKE) -C ./ck_hp/validate all
 	$(MAKE) -C ./ck_hp/benchmark all
+	$(MAKE) -C ./ck_ec/validate all
+	$(MAKE) -C ./ck_ec/benchmark all
 
 clean:
 	$(MAKE) -C ./ck_array/validate clean
+	$(MAKE) -C ./ck_cc/validate clean
 	$(MAKE) -C ./ck_pflock/validate clean
 	$(MAKE) -C ./ck_pflock/benchmark clean
 	$(MAKE) -C ./ck_tflock/validate clean
@@ -116,6 +122,8 @@
 	$(MAKE) -C ./ck_pflock/benchmark clean
 	$(MAKE) -C ./ck_hp/validate clean
 	$(MAKE) -C ./ck_hp/benchmark clean
+	$(MAKE) -C ./ck_ec/validate clean
+	$(MAKE) -C ./ck_ec/benchmark clean
 
 check: all
 	rc=0; 							\

=== regressions/ck_brlock/benchmark/Makefile ===
.PHONY: clean distribution

OBJECTS=latency throughput

all: $(OBJECTS)

latency: latency.c ../../../include/ck_brlock.h
	$(CC) $(CFLAGS) -o latency latency.c

throughput: throughput.c ../../../include/ck_brlock.h
	$(CC) $(CFLAGS) -o throughput throughput.c

clean:
	rm -rf *.dSYM *.exe *~ *.o $(OBJECTS)

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE

=== regressions/ck_bytelock/benchmark/Makefile ===
.PHONY: clean distribution

OBJECTS=latency

all: $(OBJECTS)

latency: latency.c
	$(CC) $(CFLAGS) -o latency latency.c

clean:
	rm -rf *.dSYM *.exe *~ *.o $(OBJECTS)

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE

=== regressions/ck_ec/validate/Makefile ===
.PHONY: check clean distribution

FUZZER ?= none

FUZZ_CFLAGS ?=

# See http://gallium.inria.fr/blog/portable-conditionals-in-makefiles/ for
# the portable conditional technique below.
none_fuzz_cflags =
libfuzzer_fuzz_cflags = -DUSE_LIBFUZZER -fsanitize=fuzzer,memory,undefined

FUZZ_CFLAGS += ${${FUZZER}_fuzz_cflags}

OBJECTS = ck_ec_smoke_test 		\
	prop_test_timeutil_add		\
	prop_test_timeutil_add_ns	\
	prop_test_timeutil_cmp		\
	prop_test_timeutil_scale	\
	prop_test_value 			\
	prop_test_wakeup			\
	prop_test_slow_wakeup

all: $(OBJECTS)

check: all
	./ck_ec_smoke_test
        # the command line arguments are only consumed by libfuzzer.
	./prop_test_slow_wakeup -max_total_time=60
	./prop_test_timeutil_add -max_total_time=60
	./prop_test_timeutil_add_ns -max_total_time=60
	./prop_test_timeutil_cmp -max_total_time=60
	./prop_test_timeutil_scale -max_total_time=60
	./prop_test_value -max_total_time=60
	./prop_test_wakeup -max_total_time=60

quickfuzz: all
	./prop_test_slow_wakeup -max_total_time=5
	./prop_test_timeutil_add -max_total_time=5
	./prop_test_timeutil_add_ns -max_total_time=5
	./prop_test_timeutil_cmp -max_total_time=5
	./prop_test_timeutil_scale -max_total_time=5
	./prop_test_value -max_total_time=5
	./prop_test_wakeup -max_total_time=5

ck_ec_smoke_test: ../../../src/ck_ec.c ck_ec_smoke_test.c ../../../src/ck_ec_timeutil.h ../../../include/ck_ec.h
	$(CC) $(CFLAGS) -std=gnu11 ../../../src/ck_ec.c -o ck_ec_smoke_test ck_ec_smoke_test.c

prop_test_slow_wakeup: ../../../src/ck_ec.c prop_test_slow_wakeup.c ../../../src/ck_ec_timeutil.h ../../../include/ck_ec.h fuzz_harness.h
	$(CC) $(CFLAGS) $(FUZZ_CFLAGS) ../../../src/ck_ec.c -o prop_test_slow_wakeup prop_test_slow_wakeup.c

prop_test_timeutil_add: ../../../src/ck_ec.c prop_test_timeutil_add.c ../../../src/ck_ec_timeutil.h ../../../include/ck_ec.h fuzz_harness.h
	$(CC) $(CFLAGS) $(FUZZ_CFLAGS) ../../../src/ck_ec.c -o prop_test_timeutil_add prop_test_timeutil_add.c

prop_test_timeutil_add_ns: ../../../src/ck_ec.c prop_test_timeutil_add_ns.c ../../../src/ck_ec_timeutil.h ../../../include/ck_ec.h fuzz_harness.h
	$(CC) $(CFLAGS) $(FUZZ_CFLAGS) ../../../src/ck_ec.c -o prop_test_timeutil_add_ns prop_test_timeutil_add_ns.c

prop_test_timeutil_cmp: ../../../src/ck_ec.c prop_test_timeutil_cmp.c ../../../src/ck_ec_timeutil.h ../../../include/ck_ec.h fuzz_harness.h
	$(CC) $(CFLAGS) $(FUZZ_CFLAGS) ../../../src/ck_ec.c -o prop_test_timeutil_cmp prop_test_timeutil_cmp.c

prop_test_timeutil_scale: ../../../src/ck_ec.c prop_test_timeutil_scale.c ../../../src/ck_ec_timeutil.h ../../../include/ck_ec.h fuzz_harness.h
	$(CC) $(CFLAGS) $(FUZZ_CFLAGS) ../../../src/ck_ec.c -o prop_test_timeutil_scale prop_test_timeutil_scale.c

prop_test_value: ../../../src/ck_ec.c prop_test_value.c ../../../src/ck_ec_timeutil.h ../../../include/ck_ec.h fuzz_harness.h
	$(CC) $(CFLAGS) $(FUZZ_CFLAGS) ../../../src/ck_ec.c -o prop_test_value prop_test_value.c

prop_test_wakeup: ../../../src/ck_ec.c prop_test_wakeup.c ../../../src/ck_ec_timeutil.h ../../../include/ck_ec.h fuzz_harness.h
	$(CC) $(CFLAGS) $(FUZZ_CFLAGS) ../../../src/ck_ec.c -o prop_test_wakeup prop_test_wakeup.c

clean:
	rm -rf *~ *.o *.dSYM *.exe $(OBJECTS)

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE

=== regressions/ck_fifo/benchmark/Makefile ===
.PHONY: clean distribution

OBJECTS=latency

all: $(OBJECTS)

latency: latency.c
	$(CC) $(CFLAGS) -o latency latency.c

clean:
	rm -rf *~ *.o *.dSYM *.exe $(OBJECTS)

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE

=== regressions/ck_hp/benchmark/Makefile ===
.PHONY: clean distribution

OBJECTS=fifo_latency stack_latency

all: $(OBJECTS)

fifo_latency: fifo_latency.c
	$(CC) $(CFLAGS) -o fifo_latency ../../../src/ck_hp.c fifo_latency.c

stack_latency: stack_latency.c
	$(CC) $(CFLAGS) -o stack_latency ../../../src/ck_hp.c stack_latency.c

clean:
	rm -rf *~ *.o *.dSYM *.exe $(OBJECTS)

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE

=== regressions/ck_pflock/validate/Makefile ===
.PHONY: check clean distribution

OBJECTS=validate

all: $(OBJECTS)

validate: validate.c ../../../include/ck_pflock.h
	$(CC) $(CFLAGS) -o validate validate.c

check: all
	./validate $(CORES) 1

clean:
	rm -rf *.dSYM *.exe *~ *.o $(OBJECTS)

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE

=== regressions/ck_pr/benchmark/Makefile ===
.PHONY: clean

OBJECTS=ck_pr_cas_64 ck_pr_fas_64 ck_pr_cas_64_2 ck_pr_add_64 ck_pr_faa_64 ck_pr_neg_64 fp

all: $(OBJECTS)

fp: fp.c
	$(CC) $(CFLAGS) -o fp fp.c

ck_pr_cas_64_2: ck_pr_cas_64_2.c
	$(CC) $(CFLAGS) -o ck_pr_cas_64_2 ck_pr_cas_64_2.c -lm

ck_pr_cas_64: ck_pr_cas_64.c
	$(CC) $(CFLAGS) -o ck_pr_cas_64 ck_pr_cas_64.c -lm

ck_pr_fas_64: ck_pr_fas_64.c
	$(CC) $(CFLAGS) -o ck_pr_fas_64 ck_pr_fas_64.c -lm

ck_pr_add_64: ck_pr_add_64.c
	$(CC) $(CFLAGS) -o ck_pr_add_64 ck_pr_add_64.c -lm

ck_pr_faa_64: ck_pr_faa_64.c
	$(CC) $(CFLAGS) -o ck_pr_faa_64 ck_pr_faa_64.c -lm

ck_pr_neg_64: ck_pr_neg_64.c
	$(CC) $(CFLAGS) -o ck_pr_neg_64 ck_pr_neg_64.c -lm

clean:
	rm -rf *.dSYM *.exe *.o $(OBJECTS)

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE

=== regressions/ck_ring/validate/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 OBJECTS=ck_ring_spsc ck_ring_spmc ck_ring_spmc_template ck_ring_mpmc \
 	ck_ring_mpmc_template
-SIZE=16384
+SIZE=2048
 
 all: $(OBJECTS)

=== regressions/ck_rwcohort/benchmark/Makefile ===
.PHONY: clean distribution

OBJECTS=latency throughput
OBJECTS=ck_neutral.THROUGHPUT ck_neutral.LATENCY		\
	ck_rp.THROUGHPUT ck_rp.LATENCY				\
	ck_wp.THROUGHPUT ck_wp.LATENCY

all: $(OBJECTS)

ck_neutral.THROUGHPUT: ck_neutral.c
	$(CC) -DTHROUGHPUT $(CFLAGS) -o ck_neutral.THROUGHPUT ck_neutral.c

ck_neutral.LATENCY: ck_neutral.c
	$(CC) -DLATENCY $(CFLAGS) -o ck_neutral.LATENCY ck_neutral.c

ck_rp.THROUGHPUT: ck_rp.c
	$(CC) -DTHROUGHPUT $(CFLAGS) -o ck_rp.THROUGHPUT ck_rp.c

ck_rp.LATENCY: ck_rp.c
	$(CC) -DLATENCY $(CFLAGS) -o ck_rp.LATENCY ck_rp.c

ck_wp.THROUGHPUT: ck_wp.c
	$(CC) -DTHROUGHPUT $(CFLAGS) -o ck_wp.THROUGHPUT ck_wp.c

ck_wp.LATENCY: ck_wp.c
	$(CC) -DLATENCY $(CFLAGS) -o ck_wp.LATENCY ck_wp.c

clean:
	rm -rf *.dSYM *~ *.o $(OBJECTS)

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE

=== regressions/ck_spinlock/benchmark/Makefile ===
.PHONY: all clean

OBJECTS=ck_ticket.THROUGHPUT ck_ticket.LATENCY			\
	ck_mcs.THROUGHPUT ck_mcs.LATENCY			\
	ck_dec.THROUGHPUT ck_dec.LATENCY			\
	ck_cas.THROUGHPUT ck_cas.LATENCY			\
	ck_fas.THROUGHPUT ck_fas.LATENCY			\
	ck_clh.THROUGHPUT ck_clh.LATENCY			\
	linux_spinlock.THROUGHPUT linux_spinlock.LATENCY	\
	ck_ticket_pb.THROUGHPUT ck_ticket_pb.LATENCY		\
	ck_anderson.THROUGHPUT ck_anderson.LATENCY		\
	ck_spinlock.THROUGHPUT ck_spinlock.LATENCY		\
	ck_hclh.THROUGHPUT ck_hclh.LATENCY

all: $(OBJECTS)

ck_spinlock.THROUGHPUT: ck_spinlock.c
	$(CC) -DTHROUGHPUT $(CFLAGS) -o ck_spinlock.THROUGHPUT ck_spinlock.c -lm

ck_spinlock.LATENCY: ck_spinlock.c
	$(CC) -DLATENCY $(CFLAGS) -o ck_spinlock.LATENCY ck_spinlock.c -lm

ck_ticket.THROUGHPUT: ck_ticket.c
	$(CC) -DTHROUGHPUT $(CFLAGS) -o ck_ticket.THROUGHPUT ck_ticket.c -lm

ck_ticket.LATENCY: ck_ticket.c
	$(CC) -DLATENCY $(CFLAGS) -o ck_ticket.LATENCY ck_ticket.c -lm

ck_mcs.THROUGHPUT: ck_mcs.c
	$(CC) -DTHROUGHPUT $(CFLAGS) -o ck_mcs.THROUGHPUT ck_mcs.c -lm

ck_mcs.LATENCY: ck_mcs.c
	$(CC) -DLATENCY $(CFLAGS) -o ck_mcs.LATENCY ck_mcs.c -lm

ck_dec.THROUGHPUT: ck_dec.c
	$(CC) -DTHROUGHPUT $(CFLAGS) -o ck_dec.THROUGHPUT ck_dec.c -lm

ck_dec.LATENCY: ck_dec.c
	$(CC) -DLATENCY $(CFLAGS) -o ck_dec.LATENCY ck_dec.c -lm

ck_cas.THROUGHPUT: ck_cas.c
	$(CC) -DTHROUGHPUT $(CFLAGS) -o ck_cas.THROUGHPUT ck_cas.c -lm

ck_cas.LATENCY: ck_cas.c
	$(CC) -DLATENCY $(CFLAGS) -o ck_cas.LATENCY ck_cas.c -lm

ck_fas.THROUGHPUT: ck_fas.c
	$(CC) -DTHROUGHPUT $(CFLAGS) -o ck_fas.THROUGHPUT ck_fas.c -lm

ck_fas.LATENCY: ck_fas.c
	$(CC) -DLATENCY $(CFLAGS) -o ck_fas.LATENCY ck_fas.c -lm

ck_clh.THROUGHPUT: ck_clh.c
	$(CC) -DTHROUGHPUT $(CFLAGS) -o ck_clh.THROUGHPUT ck_clh.c -lm

ck_clh.LATENCY: ck_clh.c
	$(CC) -DLATENCY $(CFLAGS) -o ck_clh.LATENCY ck_clh.c -lm

ck_hclh.THROUGHPUT: ck_hclh.c
	$(CC) -DTHROUGHPUT $(CFLAGS) -o ck_hclh.THROUGHPUT ck_hclh.c -lm

ck_hclh.LATENCY: ck_hclh.c
	$(CC) -DLATENCY $(CFLAGS) -o ck_hclh.LATENCY ck_hclh.c -lm

linux_spinlock.THROUGHPUT: linux_spinlock.c
	$(CC) -DTHROUGHPUT $(CFLAGS) -o linux_spinlock.THROUGHPUT linux_spinlock.c -lm

linux_spinlock.LATENCY: linux_spinlock.c
	$(CC) -DLATENCY $(CFLAGS) -o linux_spinlock.LATENCY linux_spinlock.c -lm

ck_ticket_pb.THROUGHPUT: ck_ticket_pb.c
	$(CC) -DTHROUGHPUT $(CFLAGS) -o ck_ticket_pb.THROUGHPUT ck_ticket_pb.c -lm

ck_ticket_pb.LATENCY: ck_ticket_pb.c
	$(CC) -DLATENCY $(CFLAGS) -o ck_ticket_pb.LATENCY ck_ticket_pb.c -lm

ck_anderson.THROUGHPUT: ck_anderson.c
	$(CC) -DTHROUGHPUT $(CFLAGS) -o ck_anderson.THROUGHPUT ck_anderson.c -lm

ck_anderson.LATENCY: ck_anderson.c
	$(CC) -DLATENCY $(CFLAGS) -o ck_anderson.LATENCY ck_anderson.c -lm

clean:
	rm -rf *.dSYM *.exe $(OBJECTS)

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE

=== regressions/ck_swlock/benchmark/Makefile ===
.PHONY: clean distribution

OBJECTS=latency throughput

all: $(OBJECTS)

latency: latency.c ../../../include/ck_swlock.h
	$(CC) $(CFLAGS) -o latency latency.c

throughput: throughput.c ../../../include/ck_swlock.h
	$(CC) $(CFLAGS) -o throughput throughput.c

clean:
	rm -rf *.dSYM *.exe *~ *.o $(OBJECTS)

include ../../../build/regressions.build
CFLAGS+=$(PTHREAD_CFLAGS) -D_GNU_SOURCE

=== debian/changelog ===
ck (0.7.1-6ubuntu2) jammy; urgency=medium

  * debian/patches/armhf-with-fp.patch: do not hard-code CPU target
    based on uname.  Closes: #1009622.
  * drop -march target override, since this didn't work and now isn't needed.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Apr 2022 15:11:47 +0000

ck (0.7.1-6ubuntu1) jammy; urgency=medium

  * Set correct -march target on armhf for use of fp registers.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Apr 2022 06:33:30 +0000

ck (0.7.1-6) sid; urgency=medium

  * Uploading to sid.
  * Running test-suite only on fast-enough architectures (amd64, arm64,
    i386).

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sun, 31 Oct 2021 02:46:17 +0200

ck (0.7.1-5) sid; urgency=medium

  * Uploading to sid.
  * Skipping failing test-suite on mipsel and mips64el.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sat, 30 Oct 2021 07:06:55 +0200

ck (0.7.1-4) sid; urgency=medium

  * Uploading to sid.
  * Updating to standards version 4.6.0.
  * Fixing baseline violations on armel and i386, thanks to Adrian Bunk
    <bunk@debian.org> (Closes: #993010).

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Fri, 27 Aug 2021 04:33:50 +0200

ck (0.7.1-3) sid; urgency=medium

  * Uploading to sid.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sun, 15 Aug 2021 17:21:16 +0200

ck (0.7.1-2) experimental; urgency=medium

  * Uploading to experimental.
  * Switching architecture to linux-any to exclude hurd and kfreebsd (both
    FTBFS).

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sat, 24 Jul 2021 06:12:58 +0200

ck (0.7.1-1) experimental; urgency=medium

  * Uploading to experimental.
  * Merging upstream version 0.7.1 (Closes: #991419).
  * Updating to debhelper version 13.
  * Updating to standards version 4.5.1.
  * Building ck on any architecture (Closes: #743752, #750998).
  * Removing gbp.conf.
  * Adding rules-requires-root field.
  * Removing trailing slash in homepage field.
  * Repeating section field for all binary packages for consistency
    reasons.
  * Adding multi-arch field for libck-dev.
  * Updating package descriptions.
  * Updating and reformating copyright file.
  * Shortening debhelper install files.
  * Updating watch file.
  * Streamlining rules file.
  * Removing old dpkg-source files.
  * Removing allow-disable-sse.patch, included upstream.
  * Removing glibc-2.30.patch, included upstream.
  * Wrap and sorting debian directory.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Fri, 23 Jul 2021 13:59:39 +0200

ck (0.6.0-2) unstable; urgency=medium

  * Uploading to unstable.
  * New maintainer (Closes: #991427), thanks to Robert for his past work.
  * Updating vcs fields.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Fri, 23 Jul 2021 13:25:19 +0200

ck (0.6.0-1.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Explicitly set the platform option when building for armhf
    rather than rely on the configure script's autodetection.

 -- JCF Ploemen (jcfp) <linux@jcf.pm>  Sat, 04 Apr 2020 05:20:03 +0000

ck (0.6.0-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream commit b520d58 to fix build failure against
    glibc 2.30; patch provided by Logan Rosen. (Closes: #951384)

 -- JCF Ploemen (jcfp) <linux@jcf.pm>  Fri, 27 Mar 2020 10:14:22 +0000

ck (0.6.0-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream patch to disable SSE on x86. (Closes: #906697)

 -- Dominik George <natureshadow@debian.org>  Thu, 21 Nov 2019 09:38:52 +0100

ck (0.6.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Apply patch from Niels Thykier to fix FTBFS with
    debhelper >= 11.1. (Closes: #888591)

 -- Adrian Bunk <bunk@debian.org>  Sat, 24 Feb 2018 21:32:28 +0200

=== debian/control ===
Source: ck
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Daniel Baumann <daniel.baumann@progress-linux.org>
Build-Depends:
 debhelper-compat (= 13),
Rules-Requires-Root: no
Standards-Version: 4.6.0
Homepage: http://concurrencykit.org
Vcs-Browser: https://git.progress-linux.org/users/daniel.baumann/debian/packages/ck
Vcs-Git: https://git.progress-linux.org/users/daniel.baumann/debian/packages/ck

Package: libck-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends:
 libck0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Concurrency Kit (development)
 The Concurrency Kit library implements concurrency primitives, safe memory
 reclamation mechanisms and non-blocking data structures for the research,
 design and implementation of high performance concurrent systems.
 .
 This package contains the development files.

Package: libck0
Section: libs
Architecture: linux-any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Concurrency Kit (library)
 The Concurrency Kit library implements concurrency primitives, safe memory
 reclamation mechanisms and non-blocking data structures for the research,
 design and implementation of high performance concurrent systems.
 .
 It features atomic operations, hardware transactional memory, memory barriers,
 hash tables, list, ring, stack, fifo, bitmap, safe memory reclamation,
 scalable locks, execution barriers, asymmetric synchronization and more.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

ifneq (,$(filter $(DEB_HOST_ARCH), armel x32))
	PLATFORM = --platform=unknown
endif

ifeq ($(DEB_HOST_ARCH), i386)
	PLATFORM = --disable-sse
endif

%:
	dh ${@}

override_dh_auto_configure:
	dh_auto_configure -- \
		--prefix=/usr \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--includedir=/usr/include \
		--mandir=/usr/share/man \
		--cores=2 \
		$(PLATFORM)

override_dh_auto_test:
ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 i386))
	$(MAKE) -j1 check
endif
